<?php
/**
 * Created by JetBrains PhpStorm.
 * User: francismararaujo
 * Date: 7/23/13
 * Time: 12:00 PM
 * To change this template use File | Settings | File Templates.
 */

namespace Folha\Util;


use Geral\Entities\Operador;
use Symfony\Component\Validator\Constraints\Null;

class Facade {

    const FIELD_DSORDEM = 'DSORDEM';
    const FIELD_MATRICULAINI = 'MATRICULA_INI';
    const FIELD_MATRICULAFIM = 'MATRICULA_FIM';
    const FIELD_ESTRUTURALEGAL = 'ESTRUTURA_LEGAL';
    const FIELD_ESTRUTURAGEREN = 'ESTRUTURA_GEREN';
    const FIELD_NOMEINICIAL = 'NOME_INICIAL';
    const FIELD_NOMEFINAL = 'NOME_FINAL';
    const FIELD_DTINICIAL = 'DTINICIAL';
    const FIELD_DTFINAL = 'DTFINAL';

    public static function index() {

    }

    public static function invisibleFields() {

        $invisibleFields = array(
            self::FIELD_MATRICULAINI,
            self::FIELD_MATRICULAFIM,
            self::FIELD_ESTRUTURALEGAL,
            self::FIELD_ESTRUTURAGEREN,
            self::FIELD_DTINICIAL,
            self::FIELD_DTFINAL
        );
        tk_set_invisible_fields($invisibleFields);

    }

    public static function customVisibleFields() {

        $dsordem = tk_get_field_value(self::FIELD_DSORDEM);

        switch($dsordem) {
            case 'ESTRUTURA':
                $visibleFields = array(
                    self::FIELD_ESTRUTURALEGAL,
                    self::FIELD_ESTRUTURAGEREN
                );
                $invisibleFields = array(
                    self::FIELD_MATRICULAINI,
                    self::FIELD_MATRICULAFIM,
                    self::FIELD_NOMEINICIAL,
                    self::FIELD_NOMEFINAL,
                    self::FIELD_DTINICIAL,
                    self::FIELD_DTFINAL
                );
                tk_set_visible_fields($visibleFields);
                tk_set_invisible_fields($invisibleFields);
            break;
            case 'MATRICULA':
                $visibleFields = array(
                    self::FIELD_MATRICULAINI,
                    self::FIELD_MATRICULAFIM
                );
                $invisibleFields = array(
                    self::FIELD_ESTRUTURALEGAL,
                    self::FIELD_ESTRUTURAGEREN,
                    self::FIELD_NOMEINICIAL,
                    self::FIELD_NOMEFINAL,
                    self::FIELD_DTINICIAL,
                    self::FIELD_DTFINAL
                );
                tk_set_visible_fields($visibleFields);
                tk_set_invisible_fields($invisibleFields);
            break;
            case 'ALFABETICA':
                $visibleFields = array(
                    self::FIELD_NOMEINICIAL,
                    self::FIELD_NOMEFINAL
                );
                $invisibleFields = array(
                    self::FIELD_MATRICULAINI,
                    self::FIELD_MATRICULAFIM,
                    self::FIELD_ESTRUTURALEGAL,
                    self::FIELD_ESTRUTURAGEREN,
                    self::FIELD_DTINICIAL,
                    self::FIELD_DTFINAL
                );
                tk_set_visible_fields($visibleFields);
                tk_set_invisible_fields($invisibleFields);
                break;
            case 'DATA_ADMISSAO':
                $visibleFields = array(
                    self::FIELD_DTINICIAL,
                    self::FIELD_DTFINAL

                );
                $invisibleFields = array(
                    self::FIELD_MATRICULAINI,
                    self::FIELD_MATRICULAFIM,
                    self::FIELD_ESTRUTURALEGAL,
                    self::FIELD_ESTRUTURAGEREN,
                    self::FIELD_NOMEINICIAL,
                    self::FIELD_NOMEFINAL
                );
                tk_set_visible_fields($visibleFields);
                tk_set_invisible_fields($invisibleFields);
                break;

        }

    }

    /**
     * @param $text
     * @return mixed
     * Remove os caracteres BOM da string dada. Mais informações em http://en.wikipedia.org/wiki/Byte_order_mark
     */
    public static function remove_utf8_bom($text)
    {
        $bom = pack('H*','EFBBBF');
        $text = preg_replace("/^$bom/", '', $text);
        return $text;
    }

    /**
     * @param $param
     * @param $reportName
     * @param $caminhoRelativo
     * @param $nomeArquivo
     * @param $extensao
     * @param null $nrOrg
     * @param null $cdOperador
     * @param string $format
     * @param string $mode
     * @param null $strOri
     * @param null $strDes,
     * Função para download de um arquivo TXT (ou outro formato) rederizado pelo birt-viewer. Basicamente baixa um
     * relatório no formato escolhido. Util para arquivos como CNAB, DIRF, Alelo, etc. O relatório que rederizará o
     * arquivo no formato escolhido deve estar na mesma pasta dos demais relatórios do projeto em questão. O arquivo
     * gerado será armazenado na pasta informada a partir do public com o nome de arquivo na seguinte sintax:
     * <$nomeArquivo>-<$nrOrg>-<$cdOperador>.<$extensao> onde a organização, operador e extensão são opcionais (no caso
     * de não informá-los a função suprimi o '-' / '.' ). Arquivos com mesmo nome serão sobrescritos. Também é possível
     * substituir uma string no texto do relatório por outra string informado pelo programador.
     * Exemplo de utilização:
     * $param = array('P_NRORG'=>'1002','P_COMPETENCIA'=>'01/02/2010','P_DTPAGTO'=>'25/12/2010','P_ESTRUTURA'=>'58','P_ESTRUTRESP'=>'60','P_PESSRESP'=>'1','P_NREVENTO'=>'20','P_TIPOMOVIMENTO'=>'1','P_MODALIDADECAL'=>'1','P_OCORRECAL'=>'1');
     * \Folha\Util\Facade::downloadRelatorio($param, 'alelo', 'tmp_vales_beneficios\\','alelo', 'txt', '1002', '2848');
     */
    public static function downloadRelatorio($param, $reportName, $caminhoRelativo, $nomeArquivo, $extensao, $nrOrg = null, $cdOperador = null, $format = 'txt', $mode = 'run', $strOri = null, $strDes = null){
        //Adquiri a url do relatório/arquivo txt.
        $birt = \Setforms2\Runtime\Helper\Report\TkBirtReport::getInstance();
        $birt->setReport($reportName, 'E');

        //Ajusta os parâmetros para não enviar caracteres inválidos
        foreach($param as $key=>$val)
            $param[$key] = urlencode($val);

        $birt->setParameterValuesFromArray($param, $format);
        $url = $birt->getUrl($mode);
        $url = str_replace('pdf', $extensao, $url); //$url = str_replace('pdf','txt', $url);

        $url = str_replace('report.teknisa.com', 'hrm.pebbian.com:9191', $url);

        if($nrOrg != '')    //Verifica se existe o parâmetro para concatenar o '-'
            $nrOrg = '-'.$nrOrg;
        if($cdOperador != '')
            $cdOperador = '-'.$cdOperador;
        if($extensao != '')
            $extensao = '.'.$extensao;

        //Nome final do arquivo: <caminho><nome do arquivo>-<org>-<operador>.<extensão>
        $nomeFinal = APP_PATH.'/public/'.$caminhoRelativo.'/'.$nomeArquivo.$nrOrg.$cdOperador.$extensao;
        $nomeFinal = str_replace('\\','/', $nomeFinal);

        if(!file_exists($caminhoRelativo)){                    //Se não existir a estrutura de pastas este a criará
            mkdir($caminhoRelativo, 0777, true);
        }

        //Configurações do proxy via banco de dados
//        $db = \Setforms2\Runtime\Connection::getInstance();
//        $proxyparams=$db->fetchAll('SELECT DSIPPROXY, DSPROXYUSER, DSPROXYPASS, IDUTIPROXY FROM PARAMGERAL');
//        $proxyparams=$proxyparams[0];
//
//        $fileArq = fopen ($nomeFinal, 'w+');
//        $fileUrl = curl_init($url);
//        curl_setopt_array($fileUrl, array(
//            CURLOPT_URL            => $url,
//            CURLOPT_BINARYTRANSFER => 1,
//            CURLOPT_RETURNTRANSFER => 1,
//            CURLOPT_FILE           => $fileArq,
//            CURLOPT_TIMEOUT        => 600,
//            CURLOPT_USERAGENT      => 'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)',
//            CURLOPT_PROXYPORT      => 8080,
//            CURLOPT_PROXYTYPE      => 'HTTP'
//        ));
//        if ($proxyparams[0]["IDUTIPROXY"] === 'S'){
//            curl_setopt_array($fileUrl, array(
//
//                CURLOPT_PROXY          => $proxyparams['DSIPPROXY'],
//                CURLOPT_PROXYUSERPWD   => $proxyparams['DSPROXYUSER'].':'.$proxyparams['DSPROXYPASS'],
//
//            ));
//        }
//        if(curl_exec($fileUrl) === false){
//            echo 'Curl error: ' . curl_error($fileUrl);
//        }
//        curl_close($fileUrl);
//        fclose($fileArq);

        set_time_limit(0);
        file_put_contents($nomeFinal, file_get_contents($url));

        //Adquirindo os dados do arquivo (birt) baixado e os tratando conforme as necessidades
        $conteudo = file_get_contents($nomeFinal);             //Adquiri o conteúdo do arquivo via $url
        $conteudo = str_replace("\n","\r\n", $conteudo);       //Ajusta a correta quebra de linhas
        $conteudo = str_replace($strOri, $strDes, $conteudo);  //Substitui a string strOri por strDes
        $conteudo = substr($conteudo, 0, strlen($conteudo)-2); //Eliminando o \r\n do final do arquivo
        $conteudo = self::remove_utf8_bom($conteudo);                //Remove os caracteres BOM
        $fileTxt = fopen($nomeFinal,'w');                      //Cria o arquivo. Sobrescreve se for o caso.
        fwrite($fileTxt, $conteudo);                           //Escreve no arquivo os dados
        fclose($fileTxt);                                      //Fecha o arquivo
        $fileTxt = new \TkFile($nomeFinal);                    //variável para o download do arquivo
        $fileTxt->download();                                  //Inicia o download do arquivo
    }

    /**
     * @param $relatorios
     * @param $parametros
     * @param $caminhoRelativo
     * @param $nomeArquivoZip
     * @param $nrOrg
     * @param $cdOperador
     * @param string $format
     * @param string $mode
     * @return string
     * Função para se fazer download de um pacote de relatórios compactados em formato zip. Os relatórios devem ser
     * passados no parâmetro $relatorios no formato de um vetor na seguinte estrutura:
     * array( nome_relatorio1 => array( parâmetro1 => valor1, parâmetro2 => valor2, … ), nome_relatorio2 => array( parâmetro1 => valor1, parâmetro2 => valor2, … ), … ).
     * Logicamente os parâmetro obrigatórios dos relatórios devem ser informados. Pode-se informar o formato em que
     * os relatórios serão gerados e o nome do arquivo zip. Esta função cria no public do projeto uma pasta com o nome
     * especificado no parâmetro $caminhoRelativo. Os arquivo temporário desta pasta são deletados após cada execução da
     * função (exceto o arquivo zip que é sobrescrito). Retorna null para sucesso e uma string para erro contendo a
     * descrição do mesmo.
     */
    public static function downloadPacoteRelatoriosZip($relatorios, $parametros, $caminhoRelativo, $nomeArquivoZip, $nrOrg, $cdOperador, $format = 'pdf', $mode = 'run'){
        $caminhoCompleto = APP_PATH.'/public/'.$caminhoRelativo.'/'.$nrOrg.'-'.$cdOperador;    //Converte o caminho relativo para caminho real
        $caminhoCompleto = str_replace('\\','/', $caminhoCompleto); //Substitui caracteres inválidos para a estrutura de pastas do linux
        $nomeArquivoZip = $caminhoCompleto.'/'.$nomeArquivoZip.'.zip';     //Converte o nome do arquivo em nome completo: <caminho><nome do arquivo>.zip
        //Ajusta os parâmetros para não enviar caracteres inválidos
        foreach($parametros as $key=>$val)
            $parametros[$key] = urlencode($val);
        //Se não existir a estrutura de pastas este a criará
        if(!file_exists($caminhoCompleto))
            mkdir($caminhoCompleto, 0777, true);
        //Exclui os arquivos desnecessários (em $caminhoCompleto)
        foreach (glob($caminhoCompleto.'/*.*') as $arquivo)
            unlink($arquivo);
        //Cria o arquivo zip
        $zip = new \ZipArchive();
        if (!$zip->open($nomeArquivoZip, \ZipArchive::OVERWRITE))
            return "Não foi possível criar o arquivo <$nomeArquivoZip>. Por favor contate o suporte técnico.";
        //Gera os relatórios, os adiciona ao zip e excluir os relatórios recem gerados
        foreach($relatorios as $nome){
            $nomeArquivoRelatorio = $nome.'.'.$format;
            //Adquiri a url do relatório
            $birt = \Setforms2\Runtime\Helper\Report\TkBirtReport::getInstance();
            $birt->setReport($nome, 'E');
            $birt->setParameterValuesFromArray($parametros, $format);
            $url = $birt->getUrl($mode);
            $url = str_replace('report.teknisa.com', 'hrm.pebbian.com:9191', $url);
            //Gera e grava o relatório no caminho da org-operador
            set_time_limit(0);
            file_put_contents($caminhoCompleto.'/'.$nomeArquivoRelatorio, file_get_contents($url));
            //Adiciona o arquivo gerado ao zip
            if(!$zip->addFile($caminhoRelativo.'/'.$nrOrg.'-'.$cdOperador.'/'.$nomeArquivoRelatorio, $nomeArquivoRelatorio)) {
                $zip->close();
                return "Falha ao adicionar o relatório '$nomeArquivoRelatorio' no arquivo zip.";
            }
        }
        $zip->close();
        //Download do arquivo zip
        $fileTxt = new \TkFile($nomeArquivoZip);               //variável para o download do arquivo
        $fileTxt->download();                                  //Inicia o download do arquivo

        return null;    //Indica sucesso (não há mensagens de erro)
    }

    /**
     * @param $currentRow
     *
     * Impede a exclusão e atualização caso o registro em questão é diferente da organização de trabalho do operador.
     * Por exemplo: o operador da organização X visualiza os seus registros e os da organização padrão (organização 0).
     * O usuário poderá excluir/modificar seus registros da organização X porém será impedido de excluir/modificar os
     * registros da organização 0.
     * Método que usam este código: 1007078 permiteModificaOrgTrab
     * Nos Tabs and Methods usa-se os eventos: beforeSave e onDelete
     * Windows e Tabs que o utilizam: várias. Basicamente as que possuem o filtro de organização padrão e de trabalho
     * 12/11/2014
     */
    public static function permiteModificaOrgTrab($currentRow){
        if(isset($currentRow['NRORG']))
            $orgRegistro = (int)$currentRow['NRORG']; //$orgRegistro = (int)tk_get_field_value('NRORG'); //Pode-se usar esta função (não precisa do parâmetro)
        else
            $orgRegistro = 0;
        $orgOperador = \FPA::getNrorgTrabalho();
        //Verifica se as orgs do registro e do operador são as mesmas
        if($orgRegistro != $orgOperador) {
            //Orgs do registro e do operador diferente. Impedindo ação (deletar e/ou salvar)
            //Monta os parâmetros (nome da window) para cancelar a ação
            $param  = \Setforms2\Runtime\Framework::getInstance()->getCurrentMapper()->getWindowName();
            $param .= ':';
            $param .= \Setforms2\Runtime\Framework::getInstance()->getCurrentMapper()->getTabName();
            $param .= ':tk_cancel';
            $param  = strtolower($param);
            //Cancela a ação e gera um abort
            tk_add_method('cancelRow', array($param));      //tk_add_method('cancelRow', $param);
            $mensagem = 'Operação bloqueada. Não é possível modificar/excluir um registro que não é da sua organização de trabalho.';
            tk_abort($mensagem, "info");
        }
    }

    /**
     * @param $currentRow
     * @param $actionName
     * Impede a exclusão desabilitando a action caso o registro em questão é diferente da organização de trabalho do
     * operador. Por exemplo: o operador da organização X visualiza os seus registros e os da organização padrão
     * (organização 0). O usuário poderá excluir seus registros da organização X porém será impedido de excluir os
     * registros da organização 0.
     * Método que usam este código: 1007389 permiteExclusaoOrgPadrao
     * Nos Tabs and Methods usa-se o evento: afterMoveRow
     * Windows e Tabs que o utilizam: várias. Basicamente as que possuem o filtro de organização padrão e de trabalho
     * 16/12/2014
     */
    public static function permiteExclusaoOrgPadrao($currentRow, $actionName){
//        if(isset($currentRow['NRORG']))
//            $orgRegistro = (int)$currentRow['NRORG'];
//        else
//            $orgRegistro = 0;
        $orgRegistro = (int)tk_get_field_value('NRORG'); //Pode-se usar esta função (não precisa do parâmetro)
        $orgOperador = \FPA::getNrorgTrabalho();
        //Verifica se as orgs do registro e do operador são as mesmas
        if($orgRegistro != $orgOperador) {
            //Orgs do registro e do operador diferente. Impedindo ação (desabilitando a action de exclusão)
            tk_set_disable_action($actionName);
        } else {
            tk_set_enable_action($actionName);
        }
    }

        public static function permiteNovaIncidenciaEvento(){
        $evento = tk_get_field_value('NREVENTOM');      //Captura nro do evento e tipo de indicência
        $tpInci = tk_get_field_value('NRTIPOINCIDE');
        $where = "NREVENTOM = :P_EVENTO AND NRTIPOINCIDE = :P_TPINCIDE";
        $params = array();
        $params['P_EVENTO'] = $evento;
        $params['P_TPINCIDE'] = $tpInci;
        $res = \Folha\Entities\FpaIncidevento::getObjectByWhere($where,$params);
        if($res != null){
            tk_abort("Já existe uma Incidência de Evento com o evento nº $evento e um tipo de incidência nº $tpInci.");
        }
    }
	
	/**
     * @param $nrParcNegocio
     * @param null $nrStatus
     * Carrega o 'curriculo_candidato.rptdesign' para a pessoa em questão. Usado na Window 'btl_wnd_pessoa', na Tab
     * 'btl_tab_mestre_pessoa', action 'act_btl_gera_curriculo'.
     * @internal param $nrPessoa
     */
	public static function carregaCurriculoCandidato($nrParcNegocio, $nrStatus = null){

        if (empty($nrParcNegocio)) {
            $nrorg       = \FPA::getNrorgTrabalho();
            $dsemailoper = \BancoTalentos\Logic\BTL::getEmailOper();
            $parcnegocio = Operador::findOneByDsemailoperAndNrorg($dsemailoper, $nrorg);
            $nrParcNegocio = $parcnegocio->getNrparcnegocio();
        }

		$param = array();
		$param['P_NRPARCNEGOCIO'] = $nrParcNegocio;
		$param['P_STATUS']        = $nrStatus;
		$param['P_NRORG']         = \Ambiente::getNrorg();
		$param['P_COMPETENCIA']   = \Ambiente::getDtCompetencia();
		tk_open_report_from_array("curriculo_candidato", $param, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF, 'frameset', 'birt', null, null, null);

	}
	
}