<?php
namespace Producao\Entities;

use \Geral\Entities\Filial;
use \Estoque\Entities\Lanctoestoq;
use \Geral\Entities\Setor;
use \Geral\Entities\Centcust;

class Retiradaesto extends Base\Retiradaesto
{


    public function insereRetiradaEstoq(
        $filial, $filialProc, $nrorg, $nrRetirada, $dataRetirada, $desc, $nrLancto,
        $setor, $ordem, $nrRequesto, $operInclusao
    ){
        $dtAtual = \Geral\Util\DateUtil::getDataAtual();

        /** @var $objFilial Filial */
        $objFilial = Filial::getObject(array('nrorg' => $nrorg, 'cdfilial' => $filial));
        /** @var $objLancto Lanctoestoq */
        $objLancto = Lanctoestoq::getObject(array('nrorg' => $nrorg, 'cdfilial' => $filial, 'nrlancestq' => $nrLancto));

        if ($setor) {
            /** @var $objSetor Setor */
            $objSetor = Setor::getObject(array('nrorg' => $nrorg, 'cdsetor' => $setor));
            $custo = $objSetor->getCentcust();

            $this->setSetor($objSetor);
        } else {
            $custo = null;
            $this->setCdcentcust($custo);
        }

        $this->setFilial($objFilial);
        $this->setNrretest($nrRetirada);
        $this->setDtretest($dataRetirada);
        $this->setDsretest($desc);
        $this->setCdfiliallan($filialProc);
        $this->setLancestq($objLancto);
        $this->setNrordprod($ordem);
        $this->setNrrequesto($nrRequesto);
        $this->setDtinclusao($dtAtual);
        $this->setCdoperinclusao($operInclusao);
        $this->setNrorginclusao($nrorg);

        $this->persist();
        return $this;
    }


}