<?php
/**
 * TeknisaRegra.
 *
 * @package Logic
 * @author  alessandrobartels / brunofeliciano - 12/08/2011
 */
class TeknisaRegra extends TeknisaAbstractRegra {


    /**
     * Construtor.
     *
     * @param TkEvaluator $evaluator Instancia de TkEvaluator.
     *
     * @author alessandrobartels / brunofeliciano 18/08/2011
     */
    public function __construct(TkEvaluator $evaluator){
        parent::__construct($evaluator);

    }


    /**
     * Retorna o maior valor.
     *
     * @param float $valor_1 Primeiro valor.
     * @param float $valor_2 Segundo valor.
     *
     * @return float
     *
     * @author alessandrobartels / brunofeliciano 18/08/2011
     */
    public function retornaMaiorValor ($valor_1, $valor_2){
        $valor = max($valor_1, $valor_2);
        return $valor;
    }


    /**
     * Retorna o menor valor.
     *
     * @param float $valor_1 Primeiro valor.
     * @param float $valor_2 Segundo valor.
     *
     * @return float
     *
     * @author alessandrobartels / brunofeliciano 18/08/2011
     */
    public function retornaMenorValor ($valor_1, $valor_2){
        $valor = min($valor_1, $valor_2);
        return $valor;
    }


    /**
     * Retorna o maior valor.
     *
     * @param float  $valor_1  Primeiro valor.
     * @param string $operador Operador logico.
     * @param float  $valor_2  Segundo valor.
     *
     * @return boolean
     *
     * @author brunofeliciano 18/08/2011
     */
    public function comparaValores($valor_1, $operador, $valor_2){
        $resultado = false;

        $operacao = 'if ('.$valor_1.' '.$operador.' '.$valor_2.') {';
        $operacao .= '$resultado = true; }';

        eval($operacao);

        return $resultado;
    }


    /**
     * Retorna um determinado segmento da data especificada.
     *
     * @param string $data Parametro Data.
     * @param string $tipo Tipo do segmento da data a ser retornado.
     *
     * @return integer
     *
     * @author brunofeliciano 19/08/2011
     */
    public function retornaDataPorParte($data, $tipo){
        $data = new TkDateTime($data);

        if ($tipo === 'Y' || $tipo === 'A') {
            $valor = $data->toValue(TkDateTime::YEAR);
        } else if ($tipo === 'M') {
            $valor = $data->toValue(TkDateTime::MONTH);
        } else if ($tipo === 'D') {
            $valor = $data->toValue(TkDateTime::DAY);
        }

        return $valor;
    }


    /**
     * Retorna a diferenca entre duas datas.
     *
     * @param string $data_1 Primeiro Parametro Data.
     * @param string $data_2 Segundo Parametro Data.
     * @param string $tipo   Tipo do valor a ser retornado.
     *
     * @return integer
     *
     * @author brunofeliciano 19/08/2011
     */
    public function retornaDiferencaDatas($data_1, $data_2, $tipo){
        $data_1 = new TkDateTime($data_1);
        $data_2 = new TkDateTime($data_2);

        if ($tipo === 'Y' || $tipo === 'A') {
            $valor = $data_1->yearsAfter($data_2);
        } else if ($tipo === 'M') {
            $valor = $data_1->monthsAfter($data_2);
        } else if ($tipo === 'D') {
            $valor = $data_1->daysAfter($data_2);
        }

        /* @todo Verificar valor retornado dos metodos de TkDateTime */
        return $valor;
    }


    /**
     * Retorna valor aleatorio.
     *
     * @param integer $limiteMin Limite Minimo.
     * @param integer $limiteMax Limite Maximo.
     *
     * @return integer
     *
     * @author brunofeliciano 19/08/2011
     */
    public function retornaValorAleatorio($limiteMin, $limiteMax){
        $valor = rand($limiteMin, $limiteMax);
        return $valor;
    }


}