<?php
/**
 * GepMotivoFluxoLogic.
 *
 * @package Logic
 * @author  daniellepereira <username@example.com>
 */
class GepMotivoFluxoLogic {


    /**
    * Descri??o: Gera o novo c?digo de Motivo de Tramita??o por Tipo de Fluxo.
    *
    * @param integer $nrorg N?mero da Organiza??o.
    *
    * @return $codigo integer
    */
    public static function retornaProxNumeroMotivoFluxo($nrorg){
        $codigo = GepMotivofluxoEntity::retornaProxNumeroMotivoFluxo($nrorg);
        return $codigo;
    }


    /**
     * Retorna dados de um motivo atraves do tipo de fluxo.
     *
     * @param  integer $nrorg        Numero da organizacao.
     * @param  integer $nrtipofluxo  Numero do tipo de fluxo.
     *
     * @return bool|object
     */
    public static function retornaMotivo($nrorg, $nrtipofluxo){
        try{
            $dados = GepMotivofluxoEntity::retornaMotivo($nrorg, $nrtipofluxo);
            return $dados;
        } catch (Exception $e) {
            switch ($e->getCode()) {
                case GepMotivofluxoEntity::SEM_REGISTRO;
                    return false;
                default:
                    tk_message('Erro desconhecido'.$e->getMessage());
            }

        }
    }


}