/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_VERS                                                     */
/* Tabela : VERSGSIS                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_VERS'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_VERS
GO

CREATE TRIGGER DTULTATU_VERS
ON VERSGSIS
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'VERSGSIS', null, 'CDGRUPSIST='+ CDGRUPSIST+ ';'+
                                       'CDVERSGSIS='+ CDVERSGSIS+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE VERSGSIS
      SET DTULTATUVERS = GETDATE()
      FROM INSERTED;
   END;
END;
GO

